local T, IsIUP, scan_sector= ...

T.Events = {
	["HUD_SHOW"] = function(_, event, data)
		if (IsConnected() and T.tab_index == 0) then scan_sector() end
	end,
	
	["HUD_HIDE"] = function(_, event, data)
		if (IsConnected()) then T.refresh_timer:Kill() end
	end,
	
	["TARGET_CHANGED"] = function(_, event, data)
	-- Only Registered when the Targets tab is active
		if (targetlist.ScanLock()) then return end

		if (T.current_target_listindex) then
			T.display[T.current_target_listindex + T.list_offset][1].bgcolor = "0 0 0 0 *"
		end
		T.current_target_nodeid, T.current_target_objectid = radar.GetRadarSelectionID()
		T.current_target_listindex = nil
		for i, v in ipairs(T.tab_target_list) do
			if (i > T.list_count) then break end
			if (v.nodeid == T.current_target_nodeid) then
				T.display[i + T.list_offset][1].bgcolor = T.current_target_color
				T.current_target_listindex = i
				break
			end
		end
	end,
	
	["PLAYER_ENTERED_GAME"] = function(_, event, data)
		if (not IsIUP(T.display_container)) then -- don't attempt to recreate the display if they logged off previously
			T:BuildDisplay()
			T.hasmdi = false --isdeclared("mdi")
			if (T.hasmdi) then
		-- 			local contextmenu = {{
		-- 				title = function()
		-- 					if (T.pc_only) then return "Show NPCs" end
		-- 					return "Hide NPCs"
		-- 				end,
		-- 				action = togglepconly,
		-- 			}}
				mdi:CreateWindow(T.id, T.display_container, {title = "Target List", cx = 350, cy = 350}) --, contextmenu)
			else
			end
			T.Events.TARGET_CHANGED()
		end
		if (not T.hasmdi) then end
		T:CreateRegions()
	end,
	
	["PLAYER_LOGGED_OUT"] = function(_, event, data)
		if (not T.hasmdi) then end
		T:DestroyRegions()
	end,
	
	["PLUGINS_LOADED"] = function(_, event, data)
		-- Because the tutorials recreate the HUD in different ways depending on the device
		-- initial display creation has been moved to PLAYER_ENTERED_GAME
		if (IsConnected()) then end
	end,
	
	["rHUDxscale"] = function(_, event, data)
		if (not IsConnected()) then return end

		local timer = Timer()
		timer:SetTimeout(1, function()
			if (not T.hasmdi) then
				T:RebuildDisplay()
				ProcessEvent("TARGETLIST_TAB_CHANGED")
			end
		end)
	end,
	
	["UNLOAD_INTERFACE"] = function(_, event, data)
		T:DestroyRegions()
	end,

}

RegisterEvent(T.Events, "HUD_SHOW")
RegisterEvent(T.Events, "HUD_HIDE")
RegisterEvent(T.Events, "PLAYER_ENTERED_GAME")
RegisterEvent(T.Events, "PLAYER_LOGGED_OUT")
RegisterEvent(T.Events, "PLUGINS_LOADED")
RegisterEvent(T.Events, "TARGET_CHANGED")
RegisterEvent(T.Events, "rHUDxscale")
RegisterEvent(T.Events, "UNLOAD_INTERFACE")
